package com.steerinfo.baseinfo.meterbaseloaduserloadinfo.controller;

import com.steerinfo.baseinfo.meterbaseloaduserloadinfo.model.MeterBaseLoadUserloadinfo;
import com.steerinfo.baseinfo.meterbaseloaduserloadinfo.service.IMeterBaseLoadUserloadinfoService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseLoadUserloadinfo RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-03-01 03:17
 * 类描述
 * 修订历史：
 * 日期：2021-03-01
 * 作者：generator
 * 参考：
 * 描述：MeterBaseLoadUserloadinfo RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbaseloaduserloadinfos")
public class MeterBaseLoadUserloadinfoController extends BaseRESTfulController {

    @Autowired
    IMeterBaseLoadUserloadinfoService meterBaseLoadUserloadinfoService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseloaduserloadinfo:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseLoadUserloadinfo> list = meterBaseLoadUserloadinfoService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseloaduserloadinfo:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseLoadUserloadinfo> list = meterBaseLoadUserloadinfoService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseLoadUserloadinfo对象创建")
    @ApiImplicitParam(name = "meterBaseLoadUserloadinfo", value = "详细实体meterBaseLoadUserloadinfo", required = true, dataType = "MeterBaseLoadUserloadinfo")
    //@RequiresPermissions("meterbaseloaduserloadinfo:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseLoadUserloadinfo model) {
        try {
            String id = new SimpleDateFormat("yyMMddHHmmssS").format(new Date()) + ((int) (Math.random() * 90) + 10);
            model.setId(id);
            model.setUserloadinfoNo(id);
            MeterBaseLoadUserloadinfo meterBaseLoadUserloadinfo = meterBaseLoadUserloadinfoService.add(model);
            return success(meterBaseLoadUserloadinfo);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseloaduserloadinfo:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseLoadUserloadinfo meterBaseLoadUserloadinfo = meterBaseLoadUserloadinfoService.getById(id);
            return success(meterBaseLoadUserloadinfo);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseLoadUserloadinfo信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseLoadUserloadinfo", value = "详细实体meterBaseLoadUserloadinfo", required = true, dataType = "MeterBaseLoadUserloadinfo")
    })
    //@RequiresPermissions("meterbaseloaduserloadinfo:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseLoadUserloadinfo model) {
        try {
            model.setId(id);
            MeterBaseLoadUserloadinfo meterBaseLoadUserloadinfo = meterBaseLoadUserloadinfoService.modify(model);
            return success(meterBaseLoadUserloadinfo);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseloaduserloadinfo:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseLoadUserloadinfoService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "新增关联", notes = "根据MeterBaseLoadUserloadinfo对象创建；数据来源meter_base_load_point；sso用户表")
    @ApiImplicitParam(name = "MeterBaseLoadUserloadinfo", value = "详细实体MeterBaseLoadUserloadinfo", required = true, dataType = "MeterBaseLoadUserloadinfo")
    @PostMapping(value = "relation")
    public RESTfulResult relation(@RequestBody List<MeterBaseLoadUserloadinfo> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseLoadUserloadinfoService.relation(models);
            return success(num);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
